#ifndef SIDEBARVIEW_H_
#define SIDEBARVIEW_H_

#include "Sidebar.h"
#include "EditManager.h"


class SidebarView : public Sidebar {
  private:
    GtkWidget *sidebar;
    GtkWidget *entryName, *labelArea, *labelPerimeter, *buttonAdd;
    
    EditManager *editor;
    
    // prevent shallow copy
    SidebarView(const SidebarView &w);
    const SidebarView& operator=(const SidebarView &w);
    
    static void buttonClicked(GtkButton *button, SidebarView *view);
    
  public:
    SidebarView(EditManager *editor);
    virtual ~SidebarView();
    
    GtkWidget* getWidget();
    
    void update();
};

#endif /*SIDEBARVIEW_H_*/
