#ifndef UIMANAGER_H_
#define UIMANAGER_H_

#include <gtk/gtk.h>


class UIManager {
  private:
    static const gchar* const uiData;
    
    GtkUIManager *uiManager;
    
    static void handleAction(GtkAction *action, UIManager *uiManager);
    
    GtkActionGroup* createActions();
    
  public:
    UIManager();
    virtual ~UIManager();
    
    GtkWidget* getMenu() {
      return gtk_ui_manager_get_widget(uiManager, "/ui/menubar");
    }
    
    GtkWidget* getToolbar() {
      return gtk_ui_manager_get_widget(uiManager, "/ui/toolbar1");
    }
    
    GtkAccelGroup* getAccels() {
      return gtk_ui_manager_get_accel_group(uiManager);
    }
};

#endif /*UIMANAGER_H_*/
